X-Git-Url: https://git.xinqibao.xyz/dmenu.git/blobdiff_plain/28b6ea0f67ee02b0ff04a267671a255b47c21559..a662fc6e0abeacb64b5b37cedccaeee782f9454e:/dmenu_path?ds=inline

diff --git a/dmenu_path b/dmenu_path
index f64c82e..59fe64d 100755
--- a/dmenu_path
+++ b/dmenu_path
@@ -1,9 +1,9 @@
 #!/bin/sh
+CACHE=$HOME/.dmenu_cache
 IFS=:
-for dir in $PATH
-do
-	for file in "$dir"/*
-	do
-		test -x "$file" && echo "${file##*/}"
-	done
-done | sort | uniq
+
+if ! test -f "$CACHE" || find $PATH -type d -newer "$CACHE" | grep -q .; then
+	find -L $PATH -type f \( -perm -1 -o -perm -10 -o -perm -100 \) | sed 's/.*\///' | sort -u > "$CACHE"
+fi
+
+cat "$CACHE"